//------------------------------------------------------------------
//
//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1  PaleVioletRed
#property indicator_width1  2
#property indicator_minimum -5
#property indicator_maximum 105
#property indicator_level1  20
#property indicator_level3  80

//
//
//
//
//

extern int RwmaDepth         = 10;
extern int RwmaLength        = 2;
extern int RwmaPrice         = PRICE_CLOSE;
extern int StochasticLength  = 30;
extern int StochasticSlowing =  5;

//
//
//
//
//

#define MAX_depth 50
double  ma[];
double  stoch1[];
double  stoch2[];
double  ift[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0,ift);
   SetIndexBuffer(1,stoch1);
   SetIndexBuffer(2,stoch2);
   SetIndexBuffer(3,ma);
         RwmaLength = MathMax(RwmaLength,2);
         RwmaDepth  = MathMax(MathMin(RwmaDepth,MAX_depth),2);
   IndicatorShortName("IFT stochastic of RWMA ("+StochasticLength+","+StochasticSlowing+","+RwmaLength+","+RwmaDepth+")");
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double pBuffer[][MAX_depth];
int start()
{
   double weight = (RwmaLength+1)*RwmaLength*0.5;
   int i,j,r,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           int limit=Bars-counted_bars;
           if (ArrayRange(pBuffer,0) != Bars) ArrayResize(pBuffer,Bars);

   //
   //
   //
   //
   //
   
   for(i=limit, r=Bars-limit-1; i>=0; i--,r++)
   {
      double price = iMA(NULL,0,1,0,MODE_SMA,RwmaPrice,i);
      double coeff = 5;
      double sum   = 0;
      double sumc  = 0;
      for (int k=0; k<RwmaDepth; k++)
      {
         pBuffer[r][k] = price;
         if (r>RwmaLength)
         {
            for (j=0,price=0; j<RwmaLength; j++) price += (RwmaLength-j)*pBuffer[r-j][k];
                                                 price /= weight;
         }
         sum  += coeff*price;
         sumc += coeff;
         coeff = MathMax(coeff-1,1);
      }
      ma[i] = sum/sumc;
      
      //
      //
      //
      //
      //
      
      double min = ma[ArrayMinimum(ma,StochasticLength,i)];
      double max = ma[ArrayMaximum(ma,StochasticLength,i)];
            stoch1[i] = (ma[i]-min);
            stoch2[i] = (max  -min);
            double sum1=0,sum2=0; 
                  for (j=0; j<StochasticSlowing; j++)
                  {
                     sum1 += stoch1[i+j];
                     sum2 += stoch2[i+j];
                  }
            double stoch = 0; if (sum2!=0) stoch = 100.0*sum1/sum2;
            double temp  = 0.1 * (stoch - 50.0) ;
            
      //
      //
      //
      //
      //
                  
      ift[i] = ((MathExp(2*temp)-1.0)/(MathExp(2*temp)+1.0)+1.0)*50.0;
   }
   return(0);
}